<template>
  <q-page class="font column flex-center">
    <q-card>
      <q-form ref="formValidation">
        <div class="row q-mb-sm">
          <q-input
            class="q-pa-sm col-4"
            v-model="form.firstName"
            rounded
            outlined
            label="First Name"
            :rules="[rules.firstName]"
            label-color="green-9"
            bg-color="green-2"
          />
          <q-input
            class="q-pa-sm col-4"
            v-model="form.lastName"
            rounded
            outlined
            label="Last Name"
            :rules="[rules.lastName]"
            label-color="green-9"
            bg-color="green-2"
          />
          <q-input
            class="q-pa-sm col-4"
            v-model="form.middleInitial"
            rounded
            outlined
            label="Middle Initial"
            label-color="green-9"
            bg-color="green-2"
          />
        </div>
        <div class="row q-mb-sm">
          <q-select
            class="q-pa-sm col-4"
            :options="selectOptions.profession"
            v-model="form.profession"
            rounded
            outlined
            label="Profession"
            :rules="[rules.profession]"
            label-color="green-9"
            bg-color="green-2"
          />
          <q-input
            class="q-pa-sm col-grow"
            v-model="form.address"
            rounded
            outlined
            label="Hospital or Affiliation/ Address"
            :rules="[rules.address]"
            label-color="green-9"
            bg-color="green-2"
          />
        </div>
        <div class="row q-mb-sm">
          <q-input
            class="q-pa-sm col-4"
            v-model="form.prcNumber"
            rounded
            outlined
            label="PRC #"
            type="number"
            :rules="[rules.prcNumber]"
            label-color="green-9"
            bg-color="green-2"
          />
          <q-input
            v-model="form.prcValidityDate"
            rounded
            outlined
            mask="date"
            label="PRC License Validity Date"
            class="q-pa-sm col-grow"
            input-class="cursor-pointer"
            :rules="[rules.prcValidityDate]"
            label-color="green-9"
            bg-color="green-2"
          >
            <q-popup-proxy
              ref="qDateProxy"
              transition-show="scale"
              transition-hide="scale"
            >
              <q-date
                v-model="form.prcValidityDate"
                minimal
                @update:model-value="qDateProxy.hide()"
              >
                <div class="row items-center justify-end">
                  <q-btn v-close-popup label="Close" color="primary" flat />
                </div>
              </q-date>
            </q-popup-proxy>
          </q-input>
        </div>
        <div class="row">
          <q-input
            class="q-pa-sm col-4"
            v-model="form.email"
            rounded
            outlined
            label="Email"
            :rules="[rules.email]"
            label-color="green-9"
            bg-color="green-2"
          />
          <q-select
            class="q-pa-sm col-grow"
            :options="selectOptions.region"
            v-model="form.region"
            rounded
            outlined
            label="Region"
            :rules="[rules.region]"
            label-color="green-9"
            bg-color="green-2"
          />
        </div>
        <div class="row justify-end">
          <q-btn
            class="q-ma-sm"
            color="green-9"
            type="submit"
            label="SUBMIT"
            @click="register"
          />
        </div>
      </q-form>
    </q-card>
  </q-page>
</template>

<script>
import { defineComponent, ref } from 'vue'
import { useRouter } from 'vue-router'

export default defineComponent({
  name: 'Registration',
  setup() {
    const router = useRouter()
    const selectOptions = {
      profession: ['Medical Doctor', 'Staff', 'Guest'],
      region: ['Metro Manila', 'Cebu', 'Metro South', 'Metro North', 'Mindanao']
    }
    const form = ref({
      firstName: '',
      lastName: '',
      middleInitial: '',
      profession: null,
      address: '',
      prcNumber: '',
      prcValidityDate: '',
      email: '',
      region: ''
    })

    const rules = {
      firstName: (val) => val !== '' || 'First Name is required.',
      lastName: (val) => val !== '' || 'Last Name is required.',
      profession: (val) => val !== null || 'Profession is required.',
      address: (val) => val !== '' || 'Address is required.',
      prcNumber: (val) => val !== '' || 'PRC # is required.',
      prcValidityDate: (val) =>
        val !== '' || 'PRC License Validity Date is required.',
      region: (val) => val !== '' || 'Region is required.',
      email: (email) => {
        const regex =
          /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/

        return regex.test(email) || 'Email is not valid.'
      }
    }

    // Template refs
    const qDateProxy = ref(null)
    const formValidation = ref(null)

    async function register(e) {
      e.preventDefault()
      const validated = await formValidation.value.validate()
      if (validated) {
        router.replace({ name: 'complete' })
      }
    }

    return {
      selectOptions,
      formValidation,
      qDateProxy,
      form,
      rules,
      register
    }
  }
})
</script>

<style>
input[type='number']::-webkit-outer-spin-button,
input[type='number']::-webkit-inner-spin-button {
  -webkit-appearance: none;
  margin: 0;
}
</style>
